'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } // npm dependencies
//


/**
 * The SubmitButton component
 * @param  {String}   children   The label to display in the button
 * @param  {String}   name    The name for the component
 * @param  {String}   style   The style with which to display the button
 * @param  {Function} onClick The `onClick` handler for the button
 * @param  {Boolean}  isValid A flag (from the parent Form's context) indicating
 *                            whether the form to which this button is attached
 *                            is valid
 * @return {React.Element}    The React element describing this component
 */

var SubmitButton = function (_React$Component) {
    _inherits(SubmitButton, _React$Component);

    /**
     * Construct the SubmitButton instance
     * @param  {Object} props The component properties
     */
    function SubmitButton(props) {
        _classCallCheck(this, SubmitButton);

        // initialize the component state
        //
        var _this = _possibleConstructorReturn(this, (SubmitButton.__proto__ || Object.getPrototypeOf(SubmitButton)).call(this, props));

        _this.state = {
            disabled: props.disabled
        };
        return _this;
    }

    /**
     * Handle new props for the component
     * @param  {Object} newProps The new property values
     */


    _createClass(SubmitButton, [{
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(newProps) {
            // has the disabled flag state changed? if so, update the component
            // state
            //
            if (this.state.disabled !== !!newProps.disabled) {
                this.setState({ disabled: !!newProps.disabled });
            }
        }

        /**
         * Render the component
         * @return {React.Element} The React component
         */

    }, {
        key: 'render',
        value: function render() {
            return _react2.default.createElement(
                'button',
                {
                    name: this.props.name,
                    className: (0, _classnames2.default)('btn', {
                        'btn-danger': this.props.style === 'danger' || this.props.style === 'error',
                        'btn-warning': this.props.style === 'warning' || this.props.style === 'warn',
                        'btn-info': this.props.style === 'info',
                        'btn-success': this.props.style === 'success' || this.props.style === 'ok',
                        'btn-default': !this.props.style
                    }),
                    disabled: !this.context.isValid || !!this.state.disabled,
                    onClick: this.props.onClick
                },
                this.props.children || 'Submit'
            );
        }
    }]);

    return SubmitButton;
}(_react2.default.Component);

// define the property types for the component
//


SubmitButton.propTypes = {
    /** A flag indicated whether this button is disabled */
    disabled: _react2.default.PropTypes.bool,
    /** The name for the component */
    name: _react2.default.PropTypes.string,
    /** The style with which to display the button */
    style: _react2.default.PropTypes.oneOf(['danger', 'error', 'warning', 'warn', 'info', 'success', 'ok']),
    /** The `onClick` handler for the button */
    onClick: _react2.default.PropTypes.func,
    /** The child(ren) of this component */
    children: _react2.default.PropTypes.oneOfType([_react2.default.PropTypes.arrayOf(_react2.default.PropTypes.node), _react2.default.PropTypes.node])
};

// define the context types for values received from higher up the food chain
//
SubmitButton.contextTypes = {
    isValid: _react2.default.PropTypes.bool
};

// export the component
//
exports.default = SubmitButton;